#include <LPC214x.H> 
//#include "spi.h"               



extern  delay( unsigned int value );

/* SSPSR - bit definitions. */
#define TFE     0x01      /* B0 TFE Transmit FIFO Empty. This bit is 1 is the Transmit FIFO is
                               empty, 0 if not.*/
                            
                            
                            
                            
                            
                            
                           
#define TNF     0x02       /* B1 TNF Transmit FIFO Not Full. This bit is 0 if the Tx FIFO is full, 1 if not. */

#define RNE     0x04        /* B2 RNE Receive FIFO Not Empty. This bit is 0 if the Receive FIFO is
                            empty, 1 if not.*/

#define RFF     0x08       /* B3 RFF Receive FIFO Full. This bit is 1 if the Receive FIFO is full, 0 if
                            not.*/

#define BSY     0x10        /* B4 BSY Busy. This bit is 0 if the SSP controller is idle, or 1 if it is
                            currently sending/receiving a frame and/or the Tx FIFO is not
                            empty.*/

#define __PCLK    48000000

/*--------------------------- Init ------------------------------------------*/

extern Init (void) {

  /* Initialize and enable the SSP Interface module. */

  /* SSEL is GPIO, output set to high. */
  IODIR0 |= 1<<20;
  IOSET0  = 1<<20;
  PINSEL1=0X15400000;
  /* SCK1, MISO1, MOSI1 are SSP pins. */
  PINSEL1 = (PINSEL1 & ~0x000003FC) | 0x000000A8;

  /* Enable SPI in Master Mode, CPOL=0, CPHA=0. */
  SSPCR0  = 0x0007;   //8 bit transfer per data
  SSPCR1  = 0x0002;  /*The SSP controller will interact with other devices on the
                       serial bus. Software should write the appropriate control
                        information to the other SSP registers and interrupt
                           controller registers, before setting this bit. */
  SSPCPSR = 0xFE;         //pclk/254


  
}


/*--------------------------- UnInit ----------------------------------------*/

extern UnInit (void) {
  /* Return SSP interface to default state. */

  IODIR0  &= ~(1<<20);
  PINSEL1 &= ~0x000003FC;
  SSPCR1  = 0x0000;
  SSPCR0  = 0x0000;
  SSPCPSR = 0x00;
  
}


/*--------------------------- Send ------------------------------------------*/
extern unsigned char Send (unsigned char outb) {
  /* Send and Receive a byte on SPI interface. */
    while (!(SSPSR & TNF));
   SSPDR = outb;
  
    
  /* Wait if RNE cleared, Rx FIFO is empty. */
  //SSPDR = 0x03;
  while (!(SSPSR & RNE));
  return (SSPDR);
}



extern unsigned char Recive (void) 
{
  /* Send and Receive a byte on SPI interface. */
    while (!(SSPSR & TNF));
   SSPDR = 0x00;
  
    
  /* Wait if RNE cleared, Rx FIFO is empty. */
  //SSPDR = 0x03;
  while (!(SSPSR & RNE));
  return (SSPDR);
}


/*--------------------------- SendBuf ---------------------------------------*/

extern SendBuf (unsigned char *buf, unsigned int sz) {
  /* Send buffer to SPI interface. */
  unsigned int i;

  for (i = 0; i < sz; i++) {
    SSPDR = buf[i];
    /* Wait if Tx FIFO is full. */
    while (!(SSPSR & TNF));
    SSPDR;
  }
  /* Wait until Tx finished, drain Rx FIFO. */
  while (SSPSR & (BSY | RNE)) {
    SSPDR;
  }
  
}


/*--------------------------- RecBuf ----------------------------------------*/

extern  RecBuf (unsigned char *buf, unsigned int sz) {
  /* Receive SPI data to buffer. */
  unsigned int i;

  for (i = 0; i < sz; i++) {
    SSPDR = 0xFF;
    /* Wait while Rx FIFO is empty. */
    while (!(SSPSR & RNE));
    buf[i] = SSPDR;
  }
  
}




/*--------------------------- SetSS -----------------------------------------*/

extern  SetSS (unsigned int ss) {
  /* Enable/Disable SPI Chip Select (drive it high or low). */

  if (ss) {
    /* SSEL is GPIO, output set to high. */
    IOSET0 = 1<<20;
  } 
  else {
    /* SSEL is GPIO, output set to low. */
    IOCLR0 = 1<<20;
  }
  
}

extern  delay( unsigned int value )
{
 unsigned int ui_temp1,ui_temp2;
 for(ui_temp1=0;ui_temp1<value;ui_temp1++)
 for(ui_temp2=0;ui_temp2<5000;ui_temp2++);
}


